set names WIN1251;
set CLIENTLIB 'fbclient.dll';
connect 'd:\Smarket.fdb' user 'sysdba' password '3';

set term ^ ;

create or alter procedure EGAIS_XML_REG2_BALANCE (
    ID     T_DOC,
    SENDER T_CLIENT_INDEX)
returns (
    XMLSTR T_LONG_STR)
AS
declare variable GUID        T_GUID_DASHED;
declare variable IDENT       T_FID;
declare variable QUANTITY    T_QUANTITY_NULL;
declare variable ALC_CODE    T_ALC_CODE;
declare variable comment T_STR_VALUE;
declare variable REASON_NAME T_STR_VALUE;
declare variable REASON      T_FID;
declare variable WRITE_OFF   T_STRING50;
declare variable DOC_NUMBER  T_STR_VALUE;
declare variable DOC_DATE    T_DATE_NULL;
begin

  --   XML-       2  
  xmlstr = '<?xml version="1.0" encoding="UTF-8"?>'; suspend;
  xmlstr = '<ns:Documents Version="2.0"'; suspend;
  xmlstr = '  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'; suspend;
  xmlstr = '  xmlns:ns="http://fsrar.ru/WEGAIS/WB_DOC_SINGLE_01"'; suspend;
  xmlstr = '  xmlns:oref="http://fsrar.ru/WEGAIS/ClientRef_v2"'; suspend;
  xmlstr = '  xmlns:pref="http://fsrar.ru/WEGAIS/ProductRef_v2"'; suspend;
  xmlstr = '  xmlns:ainp="http://fsrar.ru/WEGAIS/ActChargeOnShop_v2" >'; suspend;

  -- 
  xmlstr = '<ns:Owner>'; suspend;
  select '<ns:FSRAR_ID>' || cp.paramvalue || '</ns:FSRAR_ID>'
    from CLIENTPARAMS cp where cp.paramtype = 14 and cp.client_id = :SENDER
  into xmlstr; suspend;
  xmlstr = '</ns:Owner>'; suspend;

  select d1.IDENTITY, d1.COMMENT, d1.REASON, r.NAME,
         d2.EGAIS_FIX_NUMBER,
         n.LINK_DOC_NUMBER, coalesce(n.LINK_DOC_DATE, d1.DOC_DATE)
    from EGAIS_REG2_DOCHEAD d1
    left join EGAIS_GET_DOC_NUMBER(d1.ID, 4, 1) n on 0=0
    left join EGAIS_REG2_DOCHEAD d2 on d2.ID = d1.REASON_ACT
    left join EGAIS_REASONS r on r.ID = d1.REASON
   where d1.ID = :ID
    into :GUID, :COMMENT, :REASON, :REASON_NAME, :WRITE_OFF, :DOC_NUMBER, :DOC_DATE;

  if (DOC_NUMBER is null) then
    DOC_NUMBER = gen_id(GEN_ACT_NUMBER, 1);

  --  
  xmlstr = '<ns:Document>'; suspend;
  xmlstr = '<ns:ActChargeOnShop_v2>'; suspend;
  xmlstr = '<ainp:Identity>' || GUID ||'</ainp:Identity>'; suspend;
  xmlstr = '<ainp:Header>'; suspend;

  xmlstr = '<ainp:ActDate>' || datetostr('yyyy-mm-dd',:DOC_DATE) || '</ainp:ActDate>'; suspend;
  xmlstr = '<ainp:Number>' || xmlcheckstr(:DOC_NUMBER) ||'</ainp:Number>'; suspend;


  xmlstr = '<ainp:TypeChargeOn>' || xmlcheckstr(REASON_NAME) || '</ainp:TypeChargeOn>'; suspend;
  if (REASON = 1) then
  begin
    xmlstr = '<ainp:ActWriteOff>' || :WRITE_OFF || '</ainp:ActWriteOff>'; suspend;
  end
  xmlstr = '<ainp:Note>'|| xmlcheckstr(COMMENT) || '</ainp:Note>'; suspend;

  xmlstr = '</ainp:Header>'; suspend;

  -- 
  xmlstr = '<ainp:Content>'; suspend;
  IDENT = 0;
  for
    select ex.QUANTITY, ex.ALC_CODE
      from EGAIS_REG2_SPEC_EXT ex
      join EGAIS_CARDS ca on ca.ALC_CODE = ex.ALC_CODE
     where ex.DOC_ID = :ID
      into :QUANTITY, :ALC_CODE
  do
  begin
    IDENT = IDENT + 1;
    xmlstr = '<ainp:Position>'; suspend;
    xmlstr = '<ainp:Identity>' || IDENT || '</ainp:Identity>'; suspend;
    xmlstr = '<ainp:Product>'; suspend;

    for
      select xmlstr
        from EGAIS_XML_PRODUCTINFO(:ALC_CODE, 2)
        into :xmlstr
    do
      suspend;

    xmlstr = '</ainp:Product>'; suspend;
    xmlstr = '<ainp:Quantity>' || doubletrunc(QUANTITY, '0.0000') || '</ainp:Quantity>'; suspend;
    xmlstr = '</ainp:Position>'; suspend;

--    update EGAIS_REG2_SPEC_EXT
--       set IDENTITY = :IDENT
--     where DOC_ID = :ID
--       and ALC_CODE = :ALC_CODE;
  end
  xmlstr = '</ainp:Content>'; suspend;
  xmlstr = '</ns:ActChargeOnShop_v2>'; suspend;
  xmlstr = '</ns:Document>'; suspend;
  xmlstr = '</ns:Documents>'; suspend;
end^

create or alter procedure EGAIS_XML_REG2_WRITEOFF (
    ID     T_DOC,
    SENDER T_CLIENT_INDEX)
returns (
    XMLSTR T_LONG_STR)
AS
declare variable GUID        T_GUID_DASHED;
declare variable QUANTITY    double precision;
declare variable ALC_CODE    T_ALC_CODE;
declare variable IDENT       integer;
declare variable comment     T_STR_VALUE;
declare variable REASON      T_STR_VALUE;
declare variable REASON_INT  integer;
declare variable DOC_NUMBER  T_STR_VALUE;
declare variable DOC_DATE    T_DATE_NULL;
declare variable PRICE       double precision;
declare variable MC          integer;
declare variable MARK        T_EGAIS_MARK;
begin
  --   XML-       2  
  xmlstr = '<?xml version="1.0" encoding="UTF-8"?>'; suspend;
  xmlstr = '<ns:Documents Version="1.0"'; suspend;
  xmlstr = '  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'; suspend;
  xmlstr = '  xmlns:ns="http://fsrar.ru/WEGAIS/WB_DOC_SINGLE_01"'; suspend;
  xmlstr = '  xmlns:oref="http://fsrar.ru/WEGAIS/ClientRef_v2"'; suspend;
  xmlstr = '  xmlns:pref="http://fsrar.ru/WEGAIS/ProductRef_v2"'; suspend;
  xmlstr = '  xmlns:ce="http://fsrar.ru/WEGAIS/CommonEnum"'; suspend;
  xmlstr = '  xmlns:awr="http://fsrar.ru/WEGAIS/ActWriteOffShop_v2" >'; suspend;

  -- 
  xmlstr = '<ns:Owner>'; suspend;
  select '<ns:FSRAR_ID>' || cp.paramvalue || '</ns:FSRAR_ID>'
    from CLIENTPARAMS cp where cp.paramtype = 14 and cp.client_id = :SENDER
  into xmlstr; suspend;
  xmlstr = '</ns:Owner>'; suspend;

  select ed.IDENTITY, ed.COMMENT, ed.REASON, r.NAME,
         n.LINK_DOC_NUMBER, coalesce(n.LINK_DOC_DATE, ed.DOC_DATE)
    from EGAIS_REG2_DOCHEAD ed
    left join EGAIS_GET_DOC_NUMBER(ed.ID, 6, 1) n on 0=0
    left join EGAIS_REASONS r on r.ID = ed.REASON

   where ed.ID = :ID
    into :GUID, :COMMENT, :REASON_INT, :REASON, :DOC_NUMBER, :DOC_DATE;

  if (DOC_NUMBER is null) then
    DOC_NUMBER = gen_id(GEN_ACT_NUMBER, 1);

  --  
  xmlstr = '<ns:Document>'; suspend;
  xmlstr = '<ns:ActWriteOffShop_v2>'; suspend;

  xmlstr = '<awr:Identity>' || GUID ||'</awr:Identity>'; suspend;
  xmlstr = '<awr:Header>'; suspend;

  xmlstr = '<awr:ActNumber>' || xmlcheckstr(:DOC_NUMBER) ||'</awr:ActNumber>'; suspend;
  xmlstr = '<awr:ActDate>' || datetostr('yyyy-mm-dd',:DOC_DATE) || '</awr:ActDate>'; suspend;


  xmlstr = '<awr:TypeWriteOff>' || xmlcheckstr(REASON) || '</awr:TypeWriteOff>'; suspend;
  xmlstr = '<awr:Note>'|| COMMENT || '</awr:Note>';

  xmlstr = '</awr:Header>'; suspend;


  -- 
  xmlstr = '<awr:Content>'; suspend;
  IDENT = 0;
  for
    select ex.QUANTITY, ex.ALC_CODE, sp.PRICE
      from EGAIS_REG2_SPEC_EXT ex
      join EGAIS_REG2_SPEC sp on sp.DOC_ID = ex.DOC_ID and sp.ARTICUL = ex.ARTICUL
      join EGAIS_CARDS ca on ca.ALC_CODE = ex.ALC_CODE
      join EGAIS_PRODUCERS pr on pr.CLIENT_REG_ID = ca.PRODUCER
     where ex.DOC_ID = :ID
      into :QUANTITY, :ALC_CODE, :PRICE
  do
  begin
    IDENT = IDENT + 1;
    xmlstr = '<awr:Position>'; suspend;
    xmlstr = '<awr:Identity>' || IDENT || '</awr:Identity>'; suspend;
    xmlstr = '<awr:Product>'; suspend;

    for
      select xmlstr
        from EGAIS_XML_PRODUCTINFO(:ALC_CODE, 2)
        into :xmlstr
    do
      suspend;

    xmlstr = '</awr:Product>'; suspend;
    xmlstr = '<awr:Quantity>' || doubletrunc(QUANTITY, '0.0000') || '</awr:Quantity>'; suspend;

    if (REASON_INT = 11) then
    begin
      xmlstr = '<awr:SumSale>'||doubletrunc(PRICE * QUANTITY,'0.00')||'</awr:SumSale>'; suspend;
    end

    select count(*)
      from EGAIS_MARKS
     where DOC_EGAIS = :ID
       and DOC_KIND = 6
       and ALC_CODE = :ALC_CODE
      into :MC;

    if (MC > 0) then
    begin
      xmlstr = '<awr:MarkCodeInfo>'; suspend;

      for
        select MARK
          from EGAIS_MARKS
         where DOC_EGAIS = :ID
           and DOC_KIND = 6
           and ALC_CODE = :ALC_CODE
          into :MARK
      do
      begin
        xmlstr = '<MarkCode>' || :MARK || '</MarkCode>'; suspend;
      end

      xmlstr = '</awr:MarkCodeInfo>'; suspend;
    end

    xmlstr = '</awr:Position>'; suspend;

  end
  xmlstr = '</awr:Content>'; suspend;
  xmlstr = '</ns:ActWriteOffShop_v2>'; suspend;
  xmlstr = '</ns:Document>'; suspend;
  xmlstr = '</ns:Documents>'; suspend;
end^

set term ; ^

commit;

